<?php // Teewars Game Class
/*
* Copyright (c) 2004-2006, woah-projekt.de
* All rights reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions
* are met:
*
* * Redistributions of source code must retain the above copyright
*   notice, this list of conditions and the following disclaimer.
* * Redistributions in binary form must reproduce the above copyright
*   notice, this list of conditions and the following disclaimer
*   in the documentation and/or other materials provided with the
*   distribution.
* * Neither the name of the phgstats project (woah-projekt.de)
*   nor the names of its contributors may be used to endorse or
*   promote products derived from this software without specific
*   prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
* "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
* LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
* FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
* COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
* INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
* BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
* CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
* LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
* ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
* POSSIBILITY OF SUCH DAMAGE.
*/

class teewars_n
{
    var $maxlen   = 1024;
    var $write    = "\xff\xff\xff\xff\xff\xff\xff\xff\xff\xffgief";
    var $s_info   = false;
    var $g_info   = false;
    var $p_info   = false;
    var $response = false;

    function getvalue($srv_value, $srv_data)
    {
        // search the value of selected rule and return it
        $srv_value = array_search ($srv_value, $srv_data);

        if ($srv_value === false)
        {
            return false;
        }
        else
        {
            $srv_value = $srv_data[$srv_value+1];

            return $srv_value;
        }
    }

    function splitdata()
    {
        // get rules from stream and write to g_info
        $this->s_info = substr($this->s_info, 18);
        $c_info = explode("\n", $this->s_info);
        $this->g_info = explode("\\", $c_info[0]);

        // get players from stream and write to p_info
        $index_old = 0;
        $index_new = 0;
        foreach ($c_info as $value)
        {
            if ($index_old >= 1)
            {
                    $this->p_info[$index_new] = $value;
                $index_new++;
            }
            $index_old++;
        }
    }

    function microtime_float()
    {
        list($usec, $sec) = explode(" ", microtime());

        return ((float)$usec + (float)$sec);
    }

    function getstream($host, $port, $queryport)
    {
        // get the infostream from server
        $socket = fsockopen('udp://'. $host, $port, $errno, $errstr, 30);

        if ($socket === false)
        {
            echo "Error: $errno - $errstr<br>\n";
        }
        else
        {
            socket_set_timeout($socket, 3);

            $time_begin = $this->microtime_float();

            fwrite($socket, $this->write);
            $this->s_info = fread($socket, $this->maxlen);

            $time_end = $this->microtime_float();
        }
        fclose($socket);

        // response time
        $this->response = $time_end - $time_begin;
        $this->response = ($this->response * 1000);
        $this->response = (int)$this->response;

        if ($this->s_info)
        {
            // sort the infostring
            $this->splitdata();

            return true;
        }
        else
        {
            return false;
        }
    }


    function getrules($phgdir)
    {
        $srv_rules['sets'] = false;

        // response time
        $srv_rules['response'] = $this->response . ' ms';

        $srv_data = split(",",str_replace(chr(00), ",", $this->g_info[0]));

        $srv_rules['hostname']  = $srv_data[1];

        $srv_rules['mapname']  = $srv_data[2];

        $srv_rules['gametype']  =  $srv_data[3];
        switch ($srv_rules['gametype'] )
        {
                case '0' : $srv_rules['gametype']  = 'Deathmatch'; break;
                case '1' : $srv_rules['gametype']  = 'Team Deathmatch'; break;
                case '2' : $srv_rules['gametype']  = 'Capture the Flag'; break;
        }

        $srv_rules['needpass']  =  $srv_data[4];

        $srv_rules['unknown']  =  $srv_data[5];

        $srv_rules['nowplayers']  =  $srv_data[6];

        $srv_rules['maxplayers']  =  $srv_data[7];

        // privileges picture
        $sets['pass'] = '<img src="' . $phgdir . 'privileges/pass.gif" alt="pw">';
        if ($srv_rules['needpass'] == 1)
        {
            $srv_rules['sets'] .= $sets['pass'];
        }

        // path to map picture and default info picture
        $srv_rules['map_path'] = 'maps/teewars';
        $srv_rules['map_default'] = 'default.jpg';

        // set gamename and version
        $srv_rules['gamename'] = "Teewars";


        // server general info
        $srv_rules['htmlinfo'] =
        '<tr><td align="left">Mapname:</td><td align="left">'
        . $srv_rules['mapname']
        . '</td></tr>' ."\n"
        . '<tr><td align="left">Players:</td><td align="left">'
        . $srv_rules['nowplayers'] . ' / ' . $srv_rules['maxplayers']
        . '</td></tr>' . "\n"
        . '<tr><td align="left">Response:</td><td align="left">'
        . $srv_rules['response']
        . '</td></tr>' . "\n"
        . '<tr><td align="left">Privileges:</td><td align="left">'
        . $srv_rules['sets']
        . '</td></tr>' . "\n";

        // server detail info
        $srv_rules['htmldetail'] =
        '<tr valign="top"><td align="left">Gamename:</td><td align="left">'
        . $srv_rules['gamename']
        . '</td></tr>' . "\n"
        . '<tr valign="top"><td align="left">Gametype:</td><td align="left">'
        . $srv_rules['gametype']
        . '</td></tr>' . "\n"
        . '<tr valign="top"><td align="left">Mapname:</td><td align="left">'
        . $srv_rules['mapname']
        . '</td></tr>' . "\n"
        . '<tr valign="top"><td align="left">Players:</td><td align="left">'
        . $srv_rules['nowplayers'] . ' / ' . $srv_rules['maxplayers']
        . '</td></tr>' . "\n"
        . '<tr valign="top"><td align="left">Response:</td><td align="left">'
        . $srv_rules['response']
        . '</td></tr>' . "\n"
        . '<tr valign="top"><td align="left">Privileges:</td><td align="left">'
        . $srv_rules['sets']
        . '</td></tr>' . "\n";

        // return all server rules
        return $srv_rules;
    }

    function getplayers()
    {
        $pl_data = split(",",str_replace(chr(00), ",", $this->g_info[0]));
        $clients= $pl_data[6];
        $players=array_slice($pl_data, 8);
        $a= $this->g_info[0];
        // set html thead
        $thead = "<tr><th>ID</th>" .
                 "<th>Name</th>" .
                 "<th>Points</th></tr>";

        // check the connected players and sort the ranking
        if ($players[0] == false)
        {
            $thead .= "<tr align=center><td>--</td>" .
                      "<td>--</td><td>--</td></tr>\n";
        }

        // store the html table line to the info array
        $srv_player = $thead;

        $index=1;
        while ($clients>0)
        {
                $player=array_shift($players);
                $points=array_shift($players);
                $tdata = "<tr align=center><td>$index.</td>" .
                     "<td>$player</td>" .
                     "<td>$points</td></tr>\n";

            $srv_player = $srv_player . $tdata;
            $clients--;
            $index++;
        }

        return $srv_player;
    }
}
